/* Ordinamento per inserimento

Scrivete un programma per la gestione di una semplice rubrica telefonica. Ogni voce della rubrica pu essere rappresentata con una struttura, avente due membri: nominativo e telefono; la rubrica nel suo complesso pu essere invece rappresentata come array di tali strutture. Potete assumere che ogni nominativo sia lungo al massimo 30 caratteri e che ci siano al pi 100 voci. Il programma dovr svolgere verie funzionalit:
- inserimento di una nuova voce;
- ricerca di un nominativo e stampa della voce relativa;
- modifica di un numero di telefono gi inserito;
- eliminazione di una voce gi inserita;
- stampa della rubrica in ordine di nominativo.

Per poter stampare la rubrica in ordine di nominativo,  utile memorizzare le nuovi voci nell'ordine corretto, adattando l'algoritmo di ordinamento per inserimento. Per effettuare la ricerca in un vettore non ordinato, dovete scorrerlo tutto, componente per componente, verificando se  quello che cercate. Se il vettore  ordinato potete usare l'algoritmo di ricerca dicotomica (vedi es ``Indovina il numero'' della esercitazione scorsa).

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* N: numero massimo di voci nella rubrica */
#define N 10

#define LUN 40
typedef char String[ LUN + 1 ];

typedef struct {
	String nome, tel;
} Voce;


/* variabili globali */
Voce rubrica[N] = { {"a aa", "142-415"}, {"ba aa", "415"}, {"c aa", "1s4fd2-415"} };
int dim = 3;

void stampa_voce( Voce );
void stampa_rubrica( void );

void inserisci_voce( void );
void elimina_voce( String nome );
int cerca_voce( String nome );
int modifica_tel( String nome );


int main( void ){
	String nome, comando;
	int i, j, c;
	
	do {
		printf( "\nMENU DEI COMANDI:\n" );
		printf( "=================\n" );
		printf( "1. per stampare la rubrica in ordine alfabetico\n" );
		printf( "2. per cercare un nominativo e stampare la voce relativa\n" );
		printf( "3. per inserire una nuova voce\n" );
		printf( "4. per eliminare una voce\n" );
		printf( "5. per modificare una voce\n" );
		printf( "=================\n" );
		
		printf( "\nInserisci un comando: " );
		gets( comando );
		c = atoi( comando );
// 		printf( "comando inserito: %d\n", c );
		
		switch ( c ) {
			case 1: 
				stampa_rubrica(); 
				break;
			case 2: 
				printf( "Nominativo da cercare: " );
				gets( nome );
				if ( ( i = cerca_voce( nome ) ) >= 0 ) {
					printf( "\nEcco la voce richiesta:\n" );
					stampa_voce( rubrica[i] );
				}
				break;
			case 3: 
				inserisci_voce();
				break;
			case 4: 
				printf( "Nominativo da eliminare: " );
				gets( nome );
				elimina_voce( nome );
				break;
			case 5: 
				printf( "Nominativo da modificare: " );
				gets( nome );
				modifica_tel( nome );
				break;
			default: return 0;	
		}
	} while ( c != 0 );
	return 0;
}

void stampa_rubrica( void ) {
	int i;
	
// 	printf( "=========================================\n\t\tRUBRICA\n=========================================\n" );
	printf( "\n\tRUBRICA\n" );
	printf( "\t*****************************************\n\n" );
	for ( i = 0; i < dim; i++ )
		stampa_voce( rubrica[i] );
}

void stampa_voce( Voce v ) {
// 	printf( "*****************************************\nNominativo: " );
	printf( "\tNominativo: " );
	puts( v.nome );
	printf( "\tTel: " );	
	puts( v.tel );
	printf( "\t*****************************************\n\n" );
	
}


void inserisci_voce( void ) {
	Voce v;
	String nome;
	int i, j;
	
	printf( "\nInserisci un nominativo: " );
	gets( nome );
	
	/* ciclo per individuare la posizione i in cui inserire v: */
	for ( i = 0; i < dim; i++) {
		if ( strcmp( nome, rubrica[i].nome ) > 0 )
			continue;
		/* trovata la posizione i, sposto in avanti i numeri pi grandi di n 
		gi memorizzati in seq (quindi nelle posizioni j >= i): */
		else {
			for ( j = dim - 1; j >= i; j--)
				rubrica[j+1] = rubrica[j];
			break;
		}
	} 
	strcpy( rubrica[i].nome, nome);
	printf( "Inserisci il relativo numero di telefono: " );
	gets( v.tel );

	dim++;
}

/* restituisce la posizione del nominativo, o -1 se il nome non  stato trovato*/
int cerca_voce( String nome ) {
	int i;
	
	for ( i = 0; i < dim; i++ )
		if ( strcmp( rubrica[i].nome, nome ) == 0 )
			return i;
	
	printf( "Il nominativo %s non  in rubrica\n", nome );
	return -1;
}

/* restituisce la posizione del nominativo, o -1 se il nome non  stato trovato*/
int modifica_tel( String nome ) {
	int i;
	
	i = cerca_voce( nome );
	if ( i >= 0 ) {
		printf( "Inserisci il nuovo numero di telefono di %s: ", nome );
		gets( rubrica[i].tel );
	}
	return i;
}

void elimina_voce( String nome ) {
	
	int i, j;
	i = cerca_voce( nome );
	
	if ( i < 0 ) return;
	
	for ( j = i; j < dim - 1 ; j++ )
		rubrica[j] = rubrica[ j+1 ];
	
	printf( "Eliminato il nominativo %s...\n", nome );
	
	dim--;
}
